/*
 * THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 *
 * Copyright (C) 2005 Apple Computer, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE COMPUTER, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE COMPUTER, INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */


#include "config.h"

#include "JSHTMLElementWrapperFactory.h"
#include "JSHTMLAnchorElement.h"
#include "JSHTMLAppletElement.h"
#include "JSHTMLAreaElement.h"
#include "JSHTMLBaseElement.h"
#include "JSHTMLBaseFontElement.h"
#include "JSHTMLBlockquoteElement.h"
#include "JSHTMLBodyElement.h"
#include "JSHTMLBRElement.h"
#include "JSHTMLButtonElement.h"
#include "JSHTMLCanvasElement.h"
#include "JSHTMLTableCaptionElement.h"
#include "JSHTMLTableColElement.h"
#include "JSHTMLModElement.h"
#include "JSHTMLDirectoryElement.h"
#include "JSHTMLDivElement.h"
#include "JSHTMLDListElement.h"
#include "JSHTMLEmbedElement.h"
#include "JSHTMLFieldSetElement.h"
#include "JSHTMLFontElement.h"
#include "JSHTMLFormElement.h"
#include "JSHTMLFrameElement.h"
#include "JSHTMLFrameSetElement.h"
#include "JSHTMLHeadingElement.h"
#include "JSHTMLHeadElement.h"
#include "JSHTMLHRElement.h"
#include "JSHTMLHtmlElement.h"
#include "JSHTMLIFrameElement.h"
#include "JSHTMLImageElement.h"
#include "JSHTMLInputElement.h"
#include "JSHTMLIsIndexElement.h"
#include "JSHTMLLabelElement.h"
#include "JSHTMLLegendElement.h"
#include "JSHTMLLIElement.h"
#include "JSHTMLLinkElement.h"
#include "JSHTMLMapElement.h"
#include "JSHTMLMarqueeElement.h"
#include "JSHTMLMenuElement.h"
#include "JSHTMLMetaElement.h"
#include "JSHTMLObjectElement.h"
#include "JSHTMLOListElement.h"
#include "JSHTMLOptGroupElement.h"
#include "JSHTMLOptionElement.h"
#include "JSHTMLParagraphElement.h"
#include "JSHTMLParamElement.h"
#include "JSHTMLPreElement.h"
#include "JSHTMLQuoteElement.h"
#include "JSHTMLScriptElement.h"
#include "JSHTMLSelectElement.h"
#include "JSHTMLStyleElement.h"
#include "JSHTMLTableElement.h"
#include "JSHTMLTableSectionElement.h"
#include "JSHTMLTableCellElement.h"
#include "JSHTMLTextAreaElement.h"
#include "JSHTMLTitleElement.h"
#include "JSHTMLTableRowElement.h"
#include "JSHTMLUListElement.h"

#include "HTMLNames.h"

#include "HTMLAnchorElement.h"
#include "HTMLAppletElement.h"
#include "HTMLAreaElement.h"
#include "HTMLBaseElement.h"
#include "HTMLBaseFontElement.h"
#include "HTMLBlockquoteElement.h"
#include "HTMLBodyElement.h"
#include "HTMLBRElement.h"
#include "HTMLButtonElement.h"
#include "HTMLCanvasElement.h"
#include "HTMLTableCaptionElement.h"
#include "HTMLTableColElement.h"
#include "HTMLModElement.h"
#include "HTMLDirectoryElement.h"
#include "HTMLDivElement.h"
#include "HTMLDListElement.h"
#include "HTMLEmbedElement.h"
#include "HTMLFieldSetElement.h"
#include "HTMLFontElement.h"
#include "HTMLFormElement.h"
#include "HTMLFrameElement.h"
#include "HTMLFrameSetElement.h"
#include "HTMLHeadingElement.h"
#include "HTMLHeadElement.h"
#include "HTMLHRElement.h"
#include "HTMLHtmlElement.h"
#include "HTMLIFrameElement.h"
#include "HTMLImageElement.h"
#include "HTMLInputElement.h"
#include "HTMLIsIndexElement.h"
#include "HTMLLabelElement.h"
#include "HTMLLegendElement.h"
#include "HTMLLIElement.h"
#include "HTMLLinkElement.h"
#include "HTMLMapElement.h"
#include "HTMLMarqueeElement.h"
#include "HTMLMenuElement.h"
#include "HTMLMetaElement.h"
#include "HTMLObjectElement.h"
#include "HTMLOListElement.h"
#include "HTMLOptGroupElement.h"
#include "HTMLOptionElement.h"
#include "HTMLParagraphElement.h"
#include "HTMLParamElement.h"
#include "HTMLPreElement.h"
#include "HTMLQuoteElement.h"
#include "HTMLScriptElement.h"
#include "HTMLSelectElement.h"
#include "HTMLStyleElement.h"
#include "HTMLTableElement.h"
#include "HTMLTableSectionElement.h"
#include "HTMLTableCellElement.h"
#include "HTMLTextAreaElement.h"
#include "HTMLTitleElement.h"
#include "HTMLTableRowElement.h"
#include "HTMLUListElement.h"
using namespace JSC;

namespace WebCore {

using namespace HTMLNames;

typedef JSNode* (*CreateHTMLElementWrapperFunction)(ExecState*, PassRefPtr<HTMLElement>);

static JSNode* createAnchorElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLAnchorElement, element.get());
}

static JSNode* createAppletElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLAppletElement, element.get());
}

static JSNode* createAreaElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLAreaElement, element.get());
}

static JSNode* createBaseElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLBaseElement, element.get());
}

static JSNode* createBaseFontElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLBaseFontElement, element.get());
}

static JSNode* createBlockquoteElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLBlockquoteElement, element.get());
}

static JSNode* createBodyElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLBodyElement, element.get());
}

static JSNode* createBRElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLBRElement, element.get());
}

static JSNode* createButtonElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLButtonElement, element.get());
}

static JSNode* createCanvasElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLCanvasElement, element.get());
}

static JSNode* createTableCaptionElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLTableCaptionElement, element.get());
}

static JSNode* createTableColElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLTableColElement, element.get());
}

static JSNode* createModElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLModElement, element.get());
}

static JSNode* createDirectoryElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLDirectoryElement, element.get());
}

static JSNode* createDivElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLDivElement, element.get());
}

static JSNode* createDListElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLDListElement, element.get());
}

static JSNode* createEmbedElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLEmbedElement, element.get());
}

static JSNode* createFieldSetElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLFieldSetElement, element.get());
}

static JSNode* createFontElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLFontElement, element.get());
}

static JSNode* createFormElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLFormElement, element.get());
}

static JSNode* createFrameElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLFrameElement, element.get());
}

static JSNode* createFrameSetElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLFrameSetElement, element.get());
}

static JSNode* createHeadingElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLHeadingElement, element.get());
}

static JSNode* createHeadElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLHeadElement, element.get());
}

static JSNode* createHRElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLHRElement, element.get());
}

static JSNode* createHtmlElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLHtmlElement, element.get());
}

static JSNode* createIFrameElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLIFrameElement, element.get());
}

static JSNode* createImageElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLImageElement, element.get());
}

static JSNode* createInputElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLInputElement, element.get());
}

static JSNode* createIsIndexElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLIsIndexElement, element.get());
}

static JSNode* createLabelElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLLabelElement, element.get());
}

static JSNode* createLegendElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLLegendElement, element.get());
}

static JSNode* createLIElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLLIElement, element.get());
}

static JSNode* createLinkElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLLinkElement, element.get());
}

static JSNode* createMapElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLMapElement, element.get());
}

static JSNode* createMarqueeElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLMarqueeElement, element.get());
}

static JSNode* createMenuElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLMenuElement, element.get());
}

static JSNode* createMetaElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLMetaElement, element.get());
}

static JSNode* createObjectElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLObjectElement, element.get());
}

static JSNode* createOListElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLOListElement, element.get());
}

static JSNode* createOptGroupElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLOptGroupElement, element.get());
}

static JSNode* createOptionElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLOptionElement, element.get());
}

static JSNode* createParagraphElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLParagraphElement, element.get());
}

static JSNode* createParamElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLParamElement, element.get());
}

static JSNode* createPreElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLPreElement, element.get());
}

static JSNode* createQuoteElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLQuoteElement, element.get());
}

static JSNode* createScriptElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLScriptElement, element.get());
}

static JSNode* createSelectElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLSelectElement, element.get());
}

static JSNode* createStyleElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLStyleElement, element.get());
}

static JSNode* createTableElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLTableElement, element.get());
}

static JSNode* createTableSectionElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLTableSectionElement, element.get());
}

static JSNode* createTableCellElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLTableCellElement, element.get());
}

static JSNode* createTextAreaElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLTextAreaElement, element.get());
}

static JSNode* createTitleElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLTitleElement, element.get());
}

static JSNode* createTableRowElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLTableRowElement, element.get());
}

static JSNode* createUListElementWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLUListElement, element.get());
}

JSNode* createJSHTMLWrapper(ExecState* exec, PassRefPtr<HTMLElement> element)
{   
    static HashMap<WebCore::AtomicStringImpl*, CreateHTMLElementWrapperFunction> map;
    if (map.isEmpty()) {
       map.set(aTag.localName().impl(), createAnchorElementWrapper);
       map.set(appletTag.localName().impl(), createAppletElementWrapper);
       map.set(areaTag.localName().impl(), createAreaElementWrapper);
       map.set(baseTag.localName().impl(), createBaseElementWrapper);
       map.set(basefontTag.localName().impl(), createBaseFontElementWrapper);
       map.set(blockquoteTag.localName().impl(), createBlockquoteElementWrapper);
       map.set(bodyTag.localName().impl(), createBodyElementWrapper);
       map.set(brTag.localName().impl(), createBRElementWrapper);
       map.set(buttonTag.localName().impl(), createButtonElementWrapper);
       map.set(canvasTag.localName().impl(), createCanvasElementWrapper);
       map.set(captionTag.localName().impl(), createTableCaptionElementWrapper);
       map.set(colTag.localName().impl(), createTableColElementWrapper);
       map.set(delTag.localName().impl(), createModElementWrapper);
       map.set(dirTag.localName().impl(), createDirectoryElementWrapper);
       map.set(divTag.localName().impl(), createDivElementWrapper);
       map.set(dlTag.localName().impl(), createDListElementWrapper);
       map.set(embedTag.localName().impl(), createEmbedElementWrapper);
       map.set(fieldsetTag.localName().impl(), createFieldSetElementWrapper);
       map.set(fontTag.localName().impl(), createFontElementWrapper);
       map.set(formTag.localName().impl(), createFormElementWrapper);
       map.set(frameTag.localName().impl(), createFrameElementWrapper);
       map.set(framesetTag.localName().impl(), createFrameSetElementWrapper);
       map.set(h1Tag.localName().impl(), createHeadingElementWrapper);
       map.set(headTag.localName().impl(), createHeadElementWrapper);
       map.set(hrTag.localName().impl(), createHRElementWrapper);
       map.set(htmlTag.localName().impl(), createHtmlElementWrapper);
       map.set(iframeTag.localName().impl(), createIFrameElementWrapper);
       map.set(imgTag.localName().impl(), createImageElementWrapper);
       map.set(inputTag.localName().impl(), createInputElementWrapper);
       map.set(isindexTag.localName().impl(), createIsIndexElementWrapper);
       map.set(labelTag.localName().impl(), createLabelElementWrapper);
       map.set(legendTag.localName().impl(), createLegendElementWrapper);
       map.set(liTag.localName().impl(), createLIElementWrapper);
       map.set(linkTag.localName().impl(), createLinkElementWrapper);
       map.set(mapTag.localName().impl(), createMapElementWrapper);
       map.set(marqueeTag.localName().impl(), createMarqueeElementWrapper);
       map.set(menuTag.localName().impl(), createMenuElementWrapper);
       map.set(metaTag.localName().impl(), createMetaElementWrapper);
       map.set(objectTag.localName().impl(), createObjectElementWrapper);
       map.set(olTag.localName().impl(), createOListElementWrapper);
       map.set(optgroupTag.localName().impl(), createOptGroupElementWrapper);
       map.set(optionTag.localName().impl(), createOptionElementWrapper);
       map.set(pTag.localName().impl(), createParagraphElementWrapper);
       map.set(paramTag.localName().impl(), createParamElementWrapper);
       map.set(preTag.localName().impl(), createPreElementWrapper);
       map.set(qTag.localName().impl(), createQuoteElementWrapper);
       map.set(scriptTag.localName().impl(), createScriptElementWrapper);
       map.set(selectTag.localName().impl(), createSelectElementWrapper);
       map.set(styleTag.localName().impl(), createStyleElementWrapper);
       map.set(tableTag.localName().impl(), createTableElementWrapper);
       map.set(tbodyTag.localName().impl(), createTableSectionElementWrapper);
       map.set(tdTag.localName().impl(), createTableCellElementWrapper);
       map.set(textareaTag.localName().impl(), createTextAreaElementWrapper);
       map.set(titleTag.localName().impl(), createTitleElementWrapper);
       map.set(trTag.localName().impl(), createTableRowElementWrapper);
       map.set(ulTag.localName().impl(), createUListElementWrapper);
       map.set(colgroupTag.localName().impl(), createTableColElementWrapper);
       map.set(h2Tag.localName().impl(), createHeadingElementWrapper);
       map.set(h3Tag.localName().impl(), createHeadingElementWrapper);
       map.set(h4Tag.localName().impl(), createHeadingElementWrapper);
       map.set(h5Tag.localName().impl(), createHeadingElementWrapper);
       map.set(h6Tag.localName().impl(), createHeadingElementWrapper);
       map.set(imageTag.localName().impl(), createImageElementWrapper);
       map.set(insTag.localName().impl(), createModElementWrapper);
       map.set(keygenTag.localName().impl(), createSelectElementWrapper);
       map.set(listingTag.localName().impl(), createPreElementWrapper);
       map.set(tfootTag.localName().impl(), createTableSectionElementWrapper);
       map.set(thTag.localName().impl(), createTableCellElementWrapper);
       map.set(theadTag.localName().impl(), createTableSectionElementWrapper);
       map.set(xmpTag.localName().impl(), createPreElementWrapper);
    }
    CreateHTMLElementWrapperFunction createWrapperFunction = map.get(element->localName().impl());
    if (createWrapperFunction)
        return createWrapperFunction(exec, element);
    return CREATE_DOM_NODE_WRAPPER(exec, HTMLElement, element.get());
}

}

